#include "stdafx.h"
#include "appmethods.h"

using namespace std;

int GetProcessSize(DWORD processID) {
	if (processID == 0) DWORD processID = GetCurrentProcessId();
	HANDLE hProcess = OpenProcess(PROCESS_QUERY_INFORMATION | PROCESS_VM_READ, 0, processID);
	HMODULE pModulepProcess;
	char pathExeW[MAX_PATH];
	char pathW[MAX_PATH];
	int size = 0;
	//char pathExe[MAX_PATH];
	DWORD flags = 0;
	pathW[0] = '\0';
	GetModuleHandleExA(flags, pathW, &pModulepProcess);
	GetModuleFileNameA(pModulepProcess, pathExeW, MAX_PATH);
	CloseHandle(hProcess);
	FILE *f = fopen(pathExeW, "rb");
	if (!f) {
		cerr << "WARNING GetProcessSize(): file process id %d not is found." << processID << endl;
		return 0;
	}
	fseek(f, 0, SEEK_END);
	size = ftell(f);
	fclose(f);
	return size;
}

char* ExtractPath(char *path) {
	//char *npath;
	for (int i = strlen(path); i >= 0; i--) {
		if (path[i] == '\\' || path[i] == '/') {
			path[i] = '\0';
			break;
		}
	}
	return path;
}

int writeLog(const char *filename, const char *mode, bool writetime, const char *fmt, ...)
{
	va_list args;
	va_start(args, fmt);
	std::vector<char> v(1024);
	while (true)
	{
		va_list args2;
		va_copy(args2, args);
		int res = vsnprintf(v.data(), v.size(), fmt, args2);
		if ((res >= 0) && (res < static_cast<int>(v.size())))
		{
			va_end(args);
			va_end(args2);
			//return std::string(v.data());

			FILE *flog = fopen(filename, mode);
			if (!flog) {
				cerr << "ERROR: file " << filename << " not is found or close access to write." << endl;
				return 0;
			}

			fseek(flog, 0, SEEK_END);
			int size = ftell(flog);
			//fprintf(flog, "size %d", size);

			if (size > log_size && log_size != -1 || size > MAX_LOG_SIZE && log_size == -1) {
				//if (log_size > MAX_LOG_SIZE) log_size = MAX_LOG_SIZE;
				cerr << "WARNING: Limited log maximal size " << size << " > " << log_size << endl;


				if (log_size > MAX_LOG_SIZE && log_size != -1) log_size = MAX_LOG_SIZE;
				//freopen(filename, "w", flog);
				fclose(flog);
				flog = fopen(filename, "w");
				fclose(flog);
				flog = fopen(filename, mode);
				if (!flog) {
					cerr << "ERROR: file " << filename << " not is found or close access to write." << endl;

					return 0;
				}

			}
			else if (log_size < MIN_LOG_SIZE && log_size != -1) {
				cerr << "WARNING: Limited log minimal size " << size << " < " << MIN_LOG_SIZE << endl;
				log_size = MIN_LOG_SIZE;
			}

			//char buffer[sizeof(v.data())+80];
			if (writetime) {
				time_t seconds = time(NULL);
				tm *timeinfo = localtime(&seconds);
				char currenttime[80];
				//asctime(timeinfo);
				char tformat[] = "%d.%m.%Y-%H:%M:%S";
				//setlocale(LC_ALL, "");
				strftime(currenttime, 80, tformat, timeinfo);
				fprintf(flog, "[%s] %s", currenttime, v.data());
			}
			else {
				fprintf(flog, v.data());
			}
			//free(buffer);

			fclose(flog);
			return 1;
		}
		size_t size;
		if (res < 0)
			size = v.size() * 2;
		else
			size = static_cast<size_t>(res) + 1;
		v.clear();
		v.resize(size);
		va_end(args2);
	}
	return 0;
}

char* GetCurrTime(const char format[]) {
	time_t seconds = time(NULL);
	tm *timeinfo = localtime(&seconds);
	char *currenttime = new char[256];
	//asctime(timeinfo);
	//char format[] = "%d.%m.%Y-%H:%M:%S";
	strftime(currenttime, 256, format, timeinfo);
	//FILE *f = fopen("ddd.log", "a");
	//freopen("ddd.log", "a", f);
	//cout << "currenttime " << currenttime << endl;
	//fclose(f);
	return (char *)currenttime;
}

char* GetProcessPath(DWORD processID) {
	if (processID == 0) DWORD processID = GetCurrentProcessId();
	HANDLE hProcess = OpenProcess(PROCESS_QUERY_INFORMATION | PROCESS_VM_READ, 0, processID);
	HMODULE pModulepProcess;
	char *pathExeW = new char[MAX_PATH];
	char pathW[MAX_PATH];
	//char pathExe[MAX_PATH];
	DWORD flags = 0;
	pathW[0] = '\0';
	GetModuleHandleExA(flags, pathW, &pModulepProcess);
	GetModuleFileNameA(pModulepProcess, pathExeW, MAX_PATH);
	//for (int i = strlen(pathExeW); i >= 0; i--) {
	//	if (pathExeW[i] == '\\' || pathExeW[i] == '/') {
	//	break;
	//	}
	//	pathExeW[i] = '\0';
	//}
	//*wcsrchr(pathExeW, '\\') = '\0';
	*strrchr(pathExeW, '\\') = '\0';
	CloseHandle(hProcess);
	return (char *)pathExeW;
}

std::string format(const char *fmt, ...)
{
	va_list args;
	va_start(args, fmt);
	std::vector<char> v(1024);
	while (true)
	{
		va_list args2;
		va_copy(args2, args);
		int res = vsnprintf(v.data(), v.size(), fmt, args2);
		if ((res >= 0) && (res < static_cast<int>(v.size())))
		{
			va_end(args);
			va_end(args2);
			return std::string(v.data());
		}
		size_t size;
		if (res < 0)
			size = v.size() * 2;
		else
			size = static_cast<size_t>(res) + 1;
		v.clear();
		v.resize(size);
		va_end(args2);
	}
}