#pragma once

//#include "stdafx.h"
#include "gta2_address.h"
#include <iostream>
#include "appmethods.h"
#include <windows.system.threading.h>
#include <experimental/filesystem>
#include <corecrt_math.h>
#include <iostream>
#include <windows.h>
#include <process.h>
#include <string.h>
#include <vector>

#if _DEBUG
	#pragma comment(lib,"lua-5.3.4/Debug/lua.lib")
#else
	#pragma comment(lib,"lua-5.3.4/Release/lua.lib")
#endif
extern "C" {
#include <lua.h>
#include <lualib.h>
#include <lauxlib.h>
}

#include <XInput.h>
#pragma comment(lib, "XInput.lib")

//extern HMODULE head_module;
//extern HANDLE head_process_handle;
//extern DWORD head_threadid;
//extern DWORD head_processid;
//extern int log_size;
//extern FILE *flog;

//#include "include/misi_native_methods.inc"
void DllExit(int param, HMODULE hModule);
void ChildThread(void *pParams);
void MainThread(void *pParams);

// System method
int l_GetGameHandle(lua_State* l); //int processid, int decimal_or_hex
int l_GetMISIBuild(lua_State* l);
int l_wait(lua_State *l);
int l_ReadProcessMemory(lua_State *l);
int l_WriteProcessMemory(lua_State *l);
int l_WriteInLog(lua_State *l);
int l_GetLogSize(lua_State *l);
int l_SetLogSize(lua_State *l);
char *GetLuaError(lua_State* l);
char *GetGameVersion(int offset, int size);
int l_IsReadPointer(lua_State *l);
int l_IsWritePointer(lua_State *l);

// Input method
int l_IsGameKeyPress(lua_State *l);
int l_IsKeyPress(lua_State *l);
int l_IsKeyDown(lua_State *l);
int l_IsKeyUp(lua_State *l);
int l_GetKeyState(lua_State *l);
int l_GetXInputConnectedDevicesNumber(lua_State* l);
int l_IsXInputKeyPress(lua_State* l);
int l_GetXInputAxes(lua_State* l);
int l_SendInput(lua_State* l);
int l_SendMenuInput(lua_State* l);

// Math method
//int l_GetDistanceOfPoints(lua_State *l);
//int l_IsArea(lua_State *l);

// Game method
int l_GetGameFrame(lua_State *l);
int l_GetNetwork(lua_State *l);
int l_GetSCRName(lua_State *l);
int l_GetMMPName(lua_State *l);
int l_GetSTYName(lua_State *l);
int l_GetGMPName(lua_State *l);
int l_GetGXTName(lua_State *l);
int l_GetSCROffset(lua_State *l);
int l_GetMaxPedDensity(lua_State *l);
int l_GetShowPedAndCarID(lua_State *l);
int l_GetShowObjID(lua_State *l);
int l_GetShowBlood(lua_State *l);
int l_GetSoundMessage(lua_State *l);
int l_GetPoliceSkip(lua_State *l);
int l_GetMedicSkip(lua_State *l);
int l_GetFiremanSkip(lua_State *l);
int l_GetRiotMode(lua_State *l);
int l_GetMaxPlayers(lua_State *l);
int l_GetPlayerFrags(lua_State *l);
int l_GetPlayerKills(lua_State *l);
int l_GetPlayerName(lua_State *l);

int l_SetPedModel(lua_State *l);
int l_SetSCRName(lua_State *l);
int l_SetMMPName(lua_State *l);
int l_SetSTYName(lua_State *l);
int l_SetGMPName(lua_State *l);
int l_SetMaxPedDensity(lua_State *l);
int l_SetShowPedAndCarID(lua_State *l);
int l_SetShowObjID(lua_State *l);
int l_SetShowBlood(lua_State *l);
int l_SetSoundMessage(lua_State *l);
int l_SetPoliceSkip(lua_State *l);
int l_SetMedicSkip(lua_State *l);
int l_SetFiremanSkip(lua_State *l);
int l_SetRiotMode(lua_State *l);
int l_SetPlayerFrags(lua_State *l);
int l_SetPlayerKills(lua_State *l);
int l_SetPlayerName(lua_State *l);

// Ped method
int l_GetPedID(lua_State *l);
int l_GetPedStruct(lua_State *l);
int l_GetPedPlayer(lua_State *l);
//int l_GetPedStructOfID(lua_State *l);
//int l_GetPedSprite(lua_State *l);
int l_GetPedCar(lua_State *l);
int l_GetPedPos(lua_State *l);
int l_GetPedAnyPos(lua_State *l);
//int l_GetPedRangeOfPoint(lua_State *l);
int l_GetPedHealth(lua_State *l);
int l_GetPedAngle(lua_State *l);
int l_GetPedAnyAngle(lua_State *l);
int l_GetPedMaxSpeed(lua_State *l);
int l_GetPedSpeed(lua_State *l);
int l_GetPedSkin(lua_State *l);
int l_GetPedModel(lua_State *l);
int l_GetPedWanted(lua_State *l);
int l_GetPedOccupation(lua_State *l);
int l_GetPedThreatReaction(lua_State *l);
int l_GetPedThreatSearch(lua_State *l);
int l_GetPedInvisible(lua_State *l);
//int l_GetPedSpecMode(lua_State *l);
int l_GetPedTask(lua_State *l);
int l_GetPedCurrentWeaponID(lua_State *l);
int l_GetPedCurrentAmmo(lua_State *l);
int l_GetPedTouch(lua_State *l);
int l_GetPedFromPoint(lua_State *l);
int l_GetPedCamPos(lua_State *l);
//int l_GetPedPool(lua_State *l);
int l_GetPedCurrentCarDoorID(lua_State *l);

int l_SetPedID(lua_State *l);
int l_SetPedPos(lua_State *l);
int l_SetPedAnyPos(lua_State *l);
int l_SetPedHealth(lua_State *l);
int l_SetPedAngle(lua_State *l);
int l_SetPedAnyAngle(lua_State *l);
int l_SetPedMaxSpeed(lua_State *l);
int l_SetPedSpeed(lua_State *l);
int l_SetPedSkin(lua_State *l);
int l_SetPedModel(lua_State *l);
int l_SetPedWanted(lua_State *l);
int l_SetPedOccupation(lua_State *l);
int l_SetPedThreatReaction(lua_State *l);
int l_SetPedThreatSearch(lua_State *l);
int l_SetPedInvisible(lua_State *l);
int l_DeletePedSprite(lua_State *l);
int l_SetPedTask(lua_State *l);
int l_SetPedCurrentWeaponID(lua_State *l);
int l_SetPedCurrentAmmo(lua_State *l);
//int l_SetPedWeapon(lua_State *l);
int l_SetPedCamPos(lua_State *l);
int l_SetPedCurrentCarDoorID(lua_State *l);
int l_IsPedDefined(lua_State *l);
int l_IsPedRangeOfPoint(lua_State *l);
int l_IsPedAnyRangeOfPoint(lua_State *l);
int l_IsPedInAnyCar(lua_State *l);
int l_IsPedInCar(lua_State *l);
int l_EnablePedSecondaryAngle(lua_State *l);
int l_DisablePedSecondaryAngle(lua_State *l);
int l_SetPedSecondaryAngle(lua_State *l);
int l_GetPedSecondaryAngle(lua_State *l);

// Player method
//int l_GetPlayerStruct(lua_State *l);
int l_GetPlayerArmour(lua_State *l);
int l_GetPlayerGameCam(lua_State *l);
int l_GetPlayerViewCam(lua_State *l);
int l_GetPlayerAuxCam(lua_State *l);
int l_GetPlayerWeaponSlot(lua_State *l);

int l_GetPlayerMoney(lua_State *l);
int l_SetPlayerArmour(lua_State *l);
int l_SetPlayerGameCam(lua_State *l);
int l_SetPlayerViewCam(lua_State *l);
int l_SetPlayerAuxCam(lua_State *l);
int l_SetPlayerWeaponSlot(lua_State *l);
int l_SetPlayerMoney(lua_State *l);

// Car method
int l_GetCarID(lua_State *l);
int l_GetCarPos(lua_State *l);
int l_GetCarAngle(lua_State *l);
int l_GetCarDamage(lua_State *l);
int l_GetCarModel(lua_State *l);
int l_GetCarColor(lua_State *l);
int l_GetCarEngine(lua_State *l);
int l_GetCarDoorLock(lua_State *l);
int l_GetCarEmergySiren(lua_State *l);
int l_GetCarHorn(lua_State *l);
int l_GetCarDirection(lua_State *l);
int l_GetCarSpeed(lua_State *l);
int l_GetCarArmour(lua_State *l);
int l_GetCarFromPoint(lua_State *l);
//int l_GetCarPool(lua_State *l);

int l_SetCarPos(lua_State *l);
int l_SetCarAngle(lua_State *l);
int l_SetCarDamage(lua_State *l);
int l_SetCarModel(lua_State *l);
int l_SetCarColor(lua_State *l);
int l_SetCarEngine(lua_State *l);
int l_SetCarDoorLock(lua_State *l);
int l_SetCarEmergySiren(lua_State *l);
int l_SetCarHorn(lua_State *l);
int l_SetCarDirection(lua_State *l);
int l_SetCarArmour(lua_State *l);

int l_IsCarRangeOfPoint(lua_State *l);

// Object methods
int l_GetObjID(lua_State *l);
int l_GetObjPos(lua_State *l);
int l_GetObjAngle(lua_State *l);
int l_GetObjModel(lua_State *l);
//int l_GetObjID(lua_State *l);

int l_SetObjPos(lua_State *l);

// Light methods
int l_GetLightPos(lua_State *l);
int l_GetLightIntensity(lua_State *l);
int l_GetLightRange(lua_State *l);
int l_GetLightColor(lua_State *l);
int l_GetLightTime(lua_State *l);

int l_SetLightPos(lua_State *l);
int l_SetLightIntensity(lua_State *l);
int l_SetLightRange(lua_State *l);
int l_SetLightColor(lua_State *l);
int l_SetLightTime(lua_State *l);

// Arrow methods
int l_GetArrowPos(lua_State *l);
int l_GetArrowAngle(lua_State *l);
int l_GetArrowColor(lua_State *l);
int l_GetArrowIcon(lua_State *l);
int l_GetArrowZoom(lua_State *l);
int l_GetArrowCurrentZoom(lua_State *l);

int l_SetArrowPos(lua_State *l);
//int l_SetArrowAngle(lua_State *l);
int l_SetArrowColor(lua_State *l);
int l_SetArrowIcon(lua_State *l);
int l_SetArrowZoom(lua_State *l);
int l_SetArrowCurrentZoom(lua_State *l);

// Sound methods
int l_GetSoundPos(lua_State *l);
int l_GetSoundID(lua_State *l);

int l_SetSoundPos(lua_State *l);
int l_SetSoundID(lua_State *l);