; -- Languages.iss --
; Demonstrates a multilingual installation.

; SEE THE DOCUMENTATION FOR DETAILS ON CREATING .ISS SCRIPT FILES!

#define AppName "MISI"
#define AppFullName "MISI ASI" 
#define AppFullName2 "MISI Library"
#define AppVersion "0.4.2"
#define AppAuthor "GTAMP community"
#define AppRelease "1 may 2018"
#define AppBuild AppName + " build v" + AppVersion + " " + AppRelease + " by " + AppAuthor
#define AppEmail "logofero@gmail.com"
#define AppURL "http://gtamp.com/forum/viewtopic.php?f=4&t=1136#p10506"
#define AppYear "2018"
#define GAME_COMPANY_DIR "DMA Design Ltd\GTA2"

[Setup]
AppName={#AppName}
AppId={#AppName}
AppVersion={#AppVersion}
;CreateAppDir=no
VersionInfoVersion=0.0.4.2
;UsePreviousAppDir=no
AppVerName={cm:MyAppVerName,0.4.2}
DefaultDirName={pf32}\{#GAME_COMPANY_DIR}
;{pf32}\{#GAME_COMPANY_DIR}
DefaultGroupName={cm:MyAppName}
UninstallDisplayIcon={app}\misi_icon2.ico
VersionInfoDescription={#AppFullName2} setup
VersionInfoProductName={#AppFullName2}
OutputDir=setup
OutputBaseFilename=misi_setup
;userdocs:Inno Setup Examples Output
LicenseFile={#file AddBackslash(SourcePath) + "MISI License.txt" }
InfoBeforeFile = {#file AddBackslash(SourcePath) + "LUA License.txt" }
;InfoAfterFile = {#file AddBackslash(SourcePath) + "LUA License.txt" }
AppCopyright={#AppName} (c) 2018 {#AppAuthor}
; Uncomment the following line to disable the "Select Setup Language"
; dialog and have it rely solely on auto-detection.
;ShowLanguageDialog=no
; If you want all languages to be listed in the "Select Setup Language"
; dialog, even those that can't be displayed in the active code page,
; uncomment the following line. Note: Unicode Inno Setup always displays
; all languages.
ShowUndisplayableLanguages=yes


[Languages]
Name: en; MessagesFile: "compiler:Default.isl"
Name: ru; MessagesFile: "compiler:Languages\Russian.isl"

[Messages]
en.BeveledLabel=English
ru.BeveledLabel=Russian

[CustomMessages]
en.MyDescription=Install LUA script examples
en.MyAppName={#AppFullName2}
en.MyAppVerName=MISI version %1
en.ReadMe=Readme File
en.Lang=English
en.Docs=MISI Documentation
en.Changes=Changes History
en.License=License
en.StageC=STAGEC (Stage Constructor)
en.Modules=Modules
en.Examples=Examples
en.FullInstall=Full installation
en.Compactnstall=Compact installation
en.CustomInstall=Custom installation
ru.MyDescription=Óñòàíîâèòü LUA ñêðèïòû ïðèìåðû
ru.MyAppName={#AppFullName2}
ru.MyAppVerName=MISI âåðñèÿ %1
ru.ReadMe=Readme ôàéë (îïèñàíèå)
ru.Lang=Ðóññêèé
ru.Docs=MISI Äîêóìåíòàöèÿ
ru.Changes=Èñòîðèÿ èçìåíåíèé
ru.License=Ëèöåíçèÿ
ru.StageC=STAGEC (Êîíñòðóêòîð óðîâíÿ)
ru.Modules=Ìîäóëè
ru.Examples=Ïðèìåðû
ru.FullInstall=Ïîëíàÿ óñòàíîâêà
ru.Compactnstall=Êîìïàêòíàÿ óñòàíîâêà
ru.CustomInstall=Âûáîðî÷íàÿ óñòàíîâêà

[Types]
Name: "full"; Description: {cm:FullInstall}
Name: "compact"; Description: {cm:Compactnstall}
Name: "custom"; Description: {cm:CustomInstall}; Flags: iscustom

[Components]
Name: "program"; Description: {cm:MyAppName}; Types: full compact custom; Flags: fixed
Name: "license"; Description: {cm:License}; Types: full compact custom; Flags: fixed
Name: "license\elua"; Description: Public Domain License; Types: full compact custom; Flags: fixed
Name: "license\mit"; Description: MIT License; Types: full compact custom; Flags: fixed
Name: "license\inno"; Description: Inno License; Types: full compact custom; Flags: fixed
Name: "stagec"; Description: {cm:StageC}; Types: full compact custom
Name: "stagec\scr"; Description: STAGEC.SCR; Types: full compact
Name: "stagec\mis"; Description: STAGEC.MIS; Types: full compact
Name: "stagec\lua"; Description: STAGEC.LUA; Types: full compact
Name: "stagec\mmp"; Description: STAGEC.MMP; Types: full compact
Name: "stagec\seq"; Description: test1.seq; Types: full compact
Name: "stagec\gxt"; Description: E.GXT; Types: full compact
Name: "modules"; Description: {cm:Modules}; Types: full compact custom
Name: "modules\arrow"; Description: arrow.lua; Types: full
Name: "modules\car"; Description: car.lua; Types: full
Name: "modules\game"; Description: game.lua; Types: full
Name: "modules\light"; Description: light.lua; Types: full
Name: "modules\obj"; Description: obj.lua; Types: full
Name: "modules\ped"; Description: ped.lua; Types: full
Name: "modules\sound"; Description: sound.lua; Types: full
Name: "modules\system"; Description: system.lua; Types: full
Name: "readme"; Description: {cm:ReadMe}; Types: full
Name: "readme\en"; Description: READMEEN Text; Types: full
Name: "readme\ru"; Description: READMERU Text; Types: full
Name: "changes"; Description: {cm:Changes}; Types: full  
Name: "changes\en"; Description: CHANGES Text; Types: full 
Name: "docs"; Description: {cm:Docs}; Types: full
Name: "docs\en"; Description: "DOCEN Text"; Types: full
Name: "docs\ru"; Description: "DOCRU Text"; Types: full
Name: "docs\input"; Description: "Input info"; Types: full
Name: "docs\sound"; Description: "Sound info"; Types: full
Name: "docs\ped"; Description: "Ped info"; Types: full
Name: "docs\car"; Description: "Car info"; Types: full
Name: "docs\block"; Description: "Block info"; Types: full
Name: "docs\arrow"; Description: "Arrow info"; Types: full
Name: "docs\obj"; Description: "Object info"; Types: full
Name: "docs\explode"; Description: "Explode info"; Types: full
Name: "examples"; Description: {cm:Examples}; Types: full
Name: "examples\1"; Description: "blank.lua"; Types: full
Name: "examples\2"; Description: "blank.txt"; Types: full
Name: "examples\3"; Description: "flashmen.txt"; Types: full
Name: "examples\4"; Description: "gamemode.lua"; Types: full
Name: "examples\5"; Description: "lightscar.txt"; Types: full
Name: "examples\6"; Description: "maploader.txt"; Types: full
Name: "examples\7"; Description: "onestart.txt"; Types: full
Name: "examples\8"; Description: "playsoundmessage.txt"; Types: full
Name: "examples\9"; Description: "rutine.txt"; Types: full
Name: "examples\10"; Description: "version.txt"; Types: full
Name: "examples\11"; Description: "getanyped.txt"; Types: full
Name: "examples\12"; Description: "buildings.txt"; Types: full
Name: "examples\13"; Description: "spawningcar.txt"; Types: full
Name: "examples\14"; Description: "gangmembers.txt"; Types: full
Name: "examples\15"; Description: "makeobj.txt"; Types: full

[Files]
Source: "MISI.ASI"; DestDir: "{app}"; Components: program
Source: "misi_icon2.ico"; DestDir: "{app}"; Components: program
Source: "misi_logo.png"; DestDir: "{app}\MISI"; Components: program
Source: "MANUAL.TXT"; DestDir: "{app}\MISI"; Components: program
Source: "Public Domain License.txt"; DestDir: "{app}\MISI\License"; Components: license\elua
Source: "MIT Software.txt"; DestDir: "{app}\MISI\License"; Components: license\mit
Source: "Inno License.txt"; DestDir: "{app}\MISI\License"; Components: license\inno
Source: "data\STAGEC.SCR"; DestDir: "{app}\MISI\data"; Components: stagec\scr
Source: "data\STAGEC.MIS"; DestDir: "{app}\MISI\Sources"; Components: stagec\mis
Source: "data\STAGEC.MMP"; DestDir: "{app}\MISI\data"; Components: stagec\mmp
Source: "data\test1.seq"; DestDir: "{app}\MISI\data"; Components: stagec\seq
Source: "data\E.GXT"; DestDir: "{app}\MISI\data"; Components: stagec\gxt
Source: "modules\STAGEC.LUA"; DestDir: "{app}\modules"; Components: stagec\lua
Source: "modules\arrow.lua"; DestDir: "{app}\modules"; Components: modules\arrow
Source: "modules\car.lua"; DestDir: "{app}\modules"; Components: modules\car
Source: "modules\game.lua"; DestDir: "{app}\modules"; Components: modules\game
Source: "modules\light.lua"; DestDir: "{app}\modules"; Components: modules\light
Source: "modules\obj.lua"; DestDir: "{app}\modules"; Components: modules\obj
Source: "modules\ped.lua"; DestDir: "{app}\modules"; Components: modules\ped
Source: "modules\sound.lua"; DestDir: "{app}\modules"; Components: modules\sound
Source: "modules\system.lua"; DestDir: "{app}\modules"; Components: modules\system
Source: "READMEEN.TXT"; DestDir: "{app}\MISI"; Components: readme\en; Flags: isreadme
Source: "READMERU.TXT"; DestDir: "{app}\MISI"; Components: readme\ru; Flags: isreadme
Source: "docs\DOCEN.TXT"; DestDir: "{app}\MISI\Docs"; Components: docs\en
Source: "docs\DOCRU.TXT"; DestDir: "{app}\MISI\Docs"; Components: docs\ru
Source: "docs\input.inc"; DestDir: "{app}\MISI\Docs"; Components: docs\input
Source: "docs\sound.inc"; DestDir: "{app}\MISI\Docs"; Components: docs\sound
Source: "docs\ped.inc"; DestDir: "{app}\MISI\Docs"; Components: docs\ped
Source: "docs\car.inc"; DestDir: "{app}\MISI\Docs"; Components: docs\car
Source: "docs\block.inc"; DestDir: "{app}\MISI\Docs"; Components: docs\block
Source: "docs\arrow.inc"; DestDir: "{app}\MISI\Docs"; Components: docs\arrow
Source: "docs\obj.inc"; DestDir: "{app}\MISI\Docs"; Components: docs\obj
Source: "docs\explode.inc"; DestDir: "{app}\MISI\Docs"; Components: docs\explode
Source: "CHANGES.TXT"; DestDir: "{app}\MISI"; Components: changes\en
Source: "examples\blank.lua"; DestDir: "{app}\scripts"; Components: examples\1
Source: "examples\blank.txt"; DestDir: "{app}\scripts"; Components: examples\2
Source: "examples\flashmen.txt"; DestDir: "{app}\MISI\Examples"; Components: examples\3
Source: "examples\gamemode.lua"; DestDir: "{app}\MISI\Examples"; Components: examples\4
Source: "examples\lightscar.txt"; DestDir: "{app}\MISI\Examples"; Components: examples\5
Source: "examples\maploader.txt"; DestDir: "{app}\MISI\Examples"; Components: examples\6
Source: "examples\onestart.txt"; DestDir: "{app}\MISI\Examples"; Components: examples\7
Source: "examples\playsoundmessage.txt"; DestDir: "{app}\MISI\Examples"; Components: examples\8
Source: "examples\rutine.txt"; DestDir: "{app}\MISI\Examples"; Components: examples\9
Source: "examples\version.txt"; DestDir: "{app}\MISI\Examples"; Components: examples\10
Source: "examples\getanyped.txt"; DestDir: "{app}\MISI\Examples"; Components: examples\11
Source: "examples\buildings.txt"; DestDir: "{app}\MISI\Examples"; Components: examples\12
Source: "examples\spawningcar.txt"; DestDir: "{app}\MISI\Examples"; Components: examples\13
Source: "examples\gangmembers.txt"; DestDir: "{app}\MISI\Examples"; Components: examples\14
Source: "examples\makeobj.txt"; DestDir: "{app}\MISI\Examples"; Components: examples\15

[Icons]
Name: "{group}\{cm:MyAppName}"; Filename: "{app}\misi_icon2.ico"
Name: "{group}\{cm:UninstallProgram,{cm:MyAppName}}"; Filename: "{uninstallexe}"

;[Tasks]
; The following task doesn't do anything and is only meant to show [CustomMessages] usage
;Name: mytask; Description: "{cm:MyDescription}"

;[Dirs]
;Name: {code:GetDataDir}; Flags: uninsneveruninstall

;[Code] 
;procedure InitializeWizard;
;var
;BackgroundBitmapImage: TBitmapImage;
;BackgroundBitmapText: TNewStaticText;
;begin
;WizardForm.BeveledLabel.Caption := ' {#AppBuild} ';
;WizardForm.BeveledLabel.Caption := '';
;end;