-- Arrow methods
-- Since: v0.4.1
local Arrow = {}

--[[
function Arrow.GetArrowPos(arrow)
	local x = 0
	local y = 0
	local z = 0
	if (arrow ~= 0) then
		x = ReadProcessMemory(arrow + 0x44, 4) / 16384
		y = ReadProcessMemory(arrow + 0x48, 4) / 16384
		z = ReadProcessMemory(arrow + 0x4C, 4) / 16384
	end
	return x, y, z
end

function Arrow.GetArrowAngle(arrow)
	local arrow_rotation = 0
	if (arrow ~= 0) then
		arrow_rotation = 360 * ReadProcessMemory(arrow + 0x8, 4) / 1439
	end
	return arrow_rotation
end

function Arrow.GetArrowZoom(arrow)
	local arrow_zoom = 0
	if (arrow ~= 0) then
		arrow_zoom = ReadProcessMemory(arrow + 0xC, 4) / 8192
	end
	return arrow_zoom
end

function Arrow.SetArrowZoom(arrow, zoom)
	if (arrow ~= 0) then
		WriteProcessMemory(arrow + 0xC, zoom * 8192, 4)
	end
end

function Arrow.GetArrowCurrentZoom(arrow)
	local arrow_zoom = 0
	if (arrow ~= 0) then
		arrow_zoom = ReadProcessMemory(arrow + 0x10, 4) / 8192
	end
	return arrow_zoom
end

function Arrow.SetArrowCurrentZoom(arrow, zoom)
	if (arrow ~= 0) then
		WriteProcessMemory(arrow + 0x10, zoom * 8192, 4)
	end
end

function Arrow.SetArrowPos(arrow, x, y, z)
	if (x >= 0 and x <= 255 and y >= 0 and y <= 255 and z >= 0 and z <= 255) then
		if (arrow ~= 0) then
			WriteProcessMemory(arrow + 0x44, x * 16384, 4)
			WriteProcessMemory(arrow + 0x48, y * 16384, 4)
			WriteProcessMemory(arrow + 0x4C, z * 16384, 4)
		end
	end
end

function Arrow.SetArrowColor(arrow, color)
	if (arrow ~= 0) then
		WriteProcessMemory(arrow + 0x20, color, 2)
	end
end

function Arrow.SetArrowModel(arrow, model)
	if (model >= 0 and model <= 114) then
		if (arrow ~= nil) then
			WriteProcessMemory(arrow + 0x24, model, 2) -- sprite id
		end
	end
end
]]--

return Arrow