-- Car methods
-- Since: v0.4.2
local Car = {CAR_NAME = {}}

Car.CAR_NAME = {
[65535] = "Unknown",
[0] = "Romero",
[1] = "Wellard",
[2] = "Aniston BD4",
[3] = "Pacifier",
[4] = "G4 Bank Van",
[5] = "Beamer",
[6] = "Box Car",
[7] = "Box Truck",
[8] = "Bug",
[10] = "Bulwark",
[11] = "Bus",
[12] = "Cop Car",
[13] = "Minx",
[14] = "Eddy",
[16] = "Panto",
[17] = "Fire Truck",
[18] = "Shark",
[19] = "GT-A1",
[21] = "Garbage Truck",
[22] = "Armed Land Roamer",
[23] = "Hot Dog Van",
[24] = "Hot Dog Dummy 1",
[25] = "Hot Dog Dummy 2",
[26] = "Hot Dog Dummy 3",
[27] = "Ice Cream Van",
[28] = "Dementia Limousine",
[29] = "Dementia",
[30] = "Land Roamer",
[31] = "Jefferson",
[32] = "Stretch Limousine",
[33] = "Sports Limousine",
[34] = "Medicar",
[35] = "Benson",
[36] = "Schmidt",
[37] = "Miara",
[38] = "Big Bug",
[39] = "Morton",
[40] = "Maurice",
[41] = "Pickup",
[42] = "A-Type",
[44] = "Arachnid",
[45] = "Spritzer",
[46] = "Stinger",
[47] = "Meteor",
[48] = "Meteor",
[49] = "Hachura",
[50] = "B-Type",
[51] = "Taxi Xpress",
[52] = "Swatvan",
[53] = "Michelli Roadster",
[54] = "Tank",
[55] = "Tanker",
[56] = "Taxi",
[57] = "T-Rex",
[58] = "Tow Truck",
[59] = "Train",
[60] = "Train Cab",
[61] = "Train FB",
[62] = "Trance Am",
[63] = "Truck Cab",
[64] = "Truck Cab SX",
[65] = "Container",
[66] = "Transporter",
[67] = "TV Van",
[68] = "Van",
[69] = "U-Jerk Truck",
[70] = "Z-Type",
[71] = "Rumbler",
[72] = "Wreck 0",
[73] = "Wreck 1",
[74] = "Wreck 2",
[75] = "Wreck 3",
[76] = "Wreck 4",
[77] = "Wreck 5",
[78] = "Wreck 6",
[79] = "Wreck 7",
[80] = "Wreck 8",
[81] = "Wreck 9",
[82] = "Jagular XK",
[83] = "Furore GT",
[84] = "Special Agent Car",
[85] = "Hot Dog Dummy",
[86] = "Karma Bus",
[87] = "Unknown"
}

--[[
function Car.SetCarArmour(car, armortype)
	if (car ~= 0) then
		WriteProcessMemory(car + 0x79, armortype, 1)
	end
end
--]]

function Car.GetNameFromModel(model)
	for car_model,car_name in pairs(Car.CAR_NAME) do
		if (car_model == model) then
			return car_name
		end
	end
	return Car.CAR_NAME[65535]
end

function Car.GetModelFromName(name)
	for car_model,car_name in pairs(Car.CAR_NAME) do
		if (car_name == name) then
			return car_model
		end
	end
	return 65535
end

function Car.GetCarName(car)
	if (car ~= 0) then
		local model = GetCarModel(car)
		for car_model,car_name in pairs(Car.CAR_NAME) do
			if (car_model == model) then
				return car_name
			end
		end
	end
	return Car.CAR_NAME[65535]
end

function Car.SetCarAlarmInit(car, state)
	if (car ~= 0) then
	    -- Set 128 give alarm
		WriteProcessMemory(car + 0x78, state, 1)
	end
end

function Car.SetCarAlarmState(car, state)
	if (car ~= 0) then
	    -- Set 8 alarm on
		WriteProcessMemory(car + 0xA4, state, 1)
	end
end

function Car.SetCarAlarmStateTimer(car, timersec)
	if (car ~= 0) then
	    -- Set 1 alarm on
		WriteProcessMemory(car + 0xA5, timersec, 1)
	end
end

function Car.SetCarAlarmEnable(car, state)
	if (car ~= 0) then
		-- Set 2 alarm ended
		-- Set 5 alram on
		WriteProcessMemory(car + 0x7C, state, 1) 
	end
end

function Car.SetCarAlarmTimer(car, timesec)
	if (car ~= 0) then
		WriteProcessMemory(car + 0x8E, timesec, 1) -- 122 bytes
	end
end

function Car.SetCarDecal(car, decalid)
	if (car ~= 0) then
		WriteProcessMemory(car + 0xA, decalid, 1)
	end
end

function Car.SetCarAlarm(car, timesec, state)
	if (car ~= 0) then
		if (state == 0) then
			car.SetCarAlarmInit(car, 0)
			car.SetCarAlarmState(car, 0)
			car.SetCarAlarmStateTimer(car, 1)
			car.SetCarAlarmTimer(car, 0)
			car.SetCarAlarmEnable(car, 0)
		elseif (state == 1) then
			car.SetCarAlarmInit(car, 128)
			car.SetCarAlarmState(car, 8)
			car.SetCarAlarmStateTimer(car, 1)
			car.SetCarAlarmTimer(car, timesec)
			car.SetCarAlarmEnable(car, 2)
		end
	end
end	

return Car